configure.in: Add --enable-install-libiberty option.
[official-gcc.git] / maintainer-scripts / gcc_release
blob1ede1f2c29e380a4ee827a1ae03337fdb0f141c0
1 #! /bin/sh
3 ########################################################################
5 # File: gcc_release
6 # Author: Jeffrey Law, Bernd Schmidt, Mark Mitchell
7 # Date: 2001-05-25
9 # Contents:
10 # Script to create a GCC release.
12 # Copyright (c) 2001, 2002 Free Software Foundation.
14 # This file is part of GNU CC.
16 # GNU CC is free software; you can redistribute it and/or modify
17 # it under the terms of the GNU General Public License as published by
18 # the Free Software Foundation; either version 2, or (at your option)
19 # any later version.
21 # GNU CC is distributed in the hope that it will be useful,
22 # but WITHOUT ANY WARRANTY; without even the implied warranty of
23 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
24 # GNU General Public License for more details.
26 # You should have received a copy of the GNU General Public License
27 # along with GNU CC; see the file COPYING. If not, write to
28 # the Free Software Foundation, 59 Temple Place - Suite 330,
29 # Boston, MA 02111-1307, USA.
31 ########################################################################
33 ########################################################################
34 # Notes
35 ########################################################################
37 # Here is an example usage of this script, to create a GCC 3.0.2
38 # prerelease:
40 # gcc_release -r 3.0.2
42 # This script will automatically use the head of the release branch
43 # to generate the release.
45 ########################################################################
46 # Functions
47 ########################################################################
49 # Issue the error message given by $1 and exit with a non-zero
50 # exit code.
52 error() {
53 echo "gcc_release: error: $1"
54 exit 1
57 # Issue the informational message given by $1.
59 inform() {
60 echo "gcc_release: $1"
63 # Issue a usage message explaining how to use this script.
65 usage() {
66 cat <<EOF
67 gcc_release [-d destination]
68 [-u username]
69 [-r release]
70 [-t tag]
71 [-p previous-tarball]
72 [-s] [-f] [-l]
73 EOF
74 exit 1
77 # Change to the directory given by $1.
79 changedir() {
80 cd $1 || \
81 error "Could not change directory to $1"
84 # Each of the arguments is a directory name, relative to the top
85 # of the source tree. Return another name for that directory, relative
86 # to the working directory.
88 adjust_dirs() {
89 for x in $@; do
90 echo `basename ${SOURCE_DIRECTORY}`/$x
91 done
94 # Build the source tree that will be the basis for the release
95 # in ${WORKING_DIRECTORY}/gcc-${RELEASE}.
97 build_sources() {
98 # If the WORKING_DIRECTORY already exists, do not risk destroying it.
99 if [ -r ${WORKING_DIRECTORY} ]; then
100 error "\`${WORKING_DIRECTORY}' already exists"
102 # Create the WORKING_DIRECTORY.
103 mkdir "${WORKING_DIRECTORY}" \
104 || error "Could not create \`${WORKING_DIRECTORY}'"
105 changedir "${WORKING_DIRECTORY}"
107 # If this is a final release, make sure that the ChangeLogs
108 # and version strings are updated.
109 if [ ${FINAL} -ne 0 ]; then
110 inform "Updating ChangeLogs and version files"
112 ${CVS} co -d "`basename ${SOURCE_DIRECTORY}`" \
113 -r ${BRANCH} gcc || \
114 error "Could not check out release sources"
115 for x in `find ${SOURCE_DIRECTORY} -name ChangeLog`; do
116 cat - ${x} > ${x}.new <<EOF
117 ${LONG_DATE} Release Manager
119 * GCC ${RELEASE} Released.
122 mv ${x}.new ${x} || \
123 error "Could not update ${x}"
124 (changedir `dirname ${x}` && \
125 ${CVS} ci -m 'Mark ChangeLog' `basename ${x}`) || \
126 error "Could not commit ${x}"
127 done
129 # Update `gcc/version.c'. There are other version files
130 # as well, which should have release status updated.
131 for x in gcc/version.c; do
132 y=`basename ${x}`
133 (changedir `dirname ${SOURCE_DIRECTORY}/${x}` && \
134 sed -e 's|= \".*\"|= \"'${RELEASE}'\"|g' < ${y} > ${y}.new && \
135 mv ${y}.new ${y} && \
136 ${CVS} ci -m 'Update version' ${y}) || \
137 error "Could not update ${x}"
138 done
139 for x in gcc/f/version.c libf2c/libF77/Version.c \
140 libf2c/libI77/Version.c libf2c/libU77/Version.c; do
141 y=`basename ${x}`
142 (changedir `dirname ${SOURCE_DIRECTORY}/${x}` && \
143 sed -e 's/experimental\|prerelease/release/g' < ${y} > ${y}.new && \
144 mv ${y}.new ${y} && \
145 ${CVS} ci -m 'Update version' ${y}) || \
146 error "Could not update ${x}"
147 done
149 # Make sure we tag the sources for a final release.
150 TAG="gcc_`echo ${RELEASE} | tr . _`_release"
152 rm -rf ${SOURCE_DIRECTORY}
155 # Tag the sources.
156 if [ -n "${TAG}" ]; then
157 inform "Tagging release sources"
158 ${CVS} rtag -r ${BRANCH} -F ${TAG} gcc || \
159 error "Could not tag release sources"
160 BRANCH=$TAG
163 # Export the current sources.
164 inform "Retrieving release sources"
165 ${CVS} \
166 export -d "`basename ${SOURCE_DIRECTORY}`" \
167 -r ${BRANCH} gcc || \
168 error "Could not retrieve release sources"
170 # Run gcc_update on them to set up the timestamps nicely.
171 changedir "gcc-${RELEASE}"
172 contrib/gcc_update --touch
174 # Obtain some documentation files from the wwwdocs module.
175 inform "Retrieving HTML documentation"
176 changedir "${WORKING_DIRECTORY}"
177 for x in bugs gnats faq; do
178 (${CVS} export -r HEAD wwwdocs/htdocs/${x}.html && \
179 cp ${WORKING_DIRECTORY}/wwwdocs/htdocs/${x}.html \
180 ${SOURCE_DIRECTORY}) || \
181 error "Could not retrieve ${x}.html"
182 done
184 inform "Generating plain-text documentation from HTML"
185 changedir "${SOURCE_DIRECTORY}"
186 for file in *.html; do
187 newfile=`echo $file | sed -e 's/.html//' | tr "[:lower:]" "[:upper:]"`
188 (${ENV} TERM=vt100 lynx -dump $file \
189 | sed -e "s#file://localhost`/bin/pwd`\(.*\)#http://gcc.gnu.org\1#g" \
190 > $newfile) || \
191 error "Could not regenerate documentation"
192 done
194 # For a prerelease or real release, we need to generate additional
195 # files not present in CVS.
196 changedir "${SOURCE_DIRECTORY}"
197 if [ $SNAPSHOT -ne 1 ]; then
198 # Generate the documentation.
199 inform "Building install docs"
200 SOURCEDIR=${SOURCE_DIRECTORY}/gcc/doc
201 DESTDIR=${SOURCE_DIRECTORY}/INSTALL
202 export SOURCEDIR
203 export DESTDIR
204 ${SOURCE_DIRECTORY}/gcc/doc/install.texi2html
206 # Regenerate the NEWS file.
207 contrib/gennews > gcc/NEWS || \
208 error "Could not regenerate NEWS files"
210 # Now, we must build the compiler in order to create any generated
211 # files that are supposed to go in the source directory. This is
212 # also a good sanity check to make sure that the release builds
213 # on at least one platform.
214 inform "Building compiler"
215 OBJECT_DIRECTORY=../objdir
216 contrib/gcc_build -d ${SOURCE_DIRECTORY} -o ${OBJECT_DIRECTORY} build || \
217 error "Could not rebuild GCC"
219 # Regenerate the Fotran NEWS and BUGS files.
220 (cd ${OBJECT_DIRECTORY}/gcc && make f77.rebuilt) || \
221 error "Could not regenerate Fortran NEWS and BUGS files"
224 # Move message catalogs to source directory.
225 mv ../objdir/gcc/po/*.gmo gcc/po/
227 # Create a `.brik' file to use for checking the validity of the
228 # release.
229 changedir "${SOURCE_DIRECTORY}"
230 BRIK_FILE=`mktemp /tmp/gcc_release.XXXXXXX`
231 ((find . -type f | sort > $BRIK_FILE) && \
232 brik -Gb -f ${BRIK_FILE} > .brik && \
233 rm ${BRIK_FILE}) || \
234 error "Could not compute brik checksum"
237 # Buid a single tarfile. The first argument is the name of the name
238 # of the tarfile to build, without any suffixes. They will be added
239 # automatically. The rest of the arguments are the files or
240 # directories to include.
242 build_tarfile() {
243 # Get the name of the destination tar file.
244 TARFILE="$1.tar.gz"
245 shift
247 # Build the tar file itself.
248 (${TAR} cf - "$@" | ${GZIP} > ${TARFILE}) || \
249 error "Could not build tarfile"
250 FILE_LIST="${FILE_LIST} ${TARFILE}"
253 # Build the various tar files for the release.
255 build_tarfiles() {
256 inform "Building tarfiles"
258 changedir "${WORKING_DIRECTORY}"
260 # The GNU Coding Standards specify that all files should
261 # world readable.
262 chmod -R a+r ${SOURCE_DIRECTORY}
263 # And that all directories have mode 777.
264 find ${SOURCE_DIRECTORY} -type d -exec chmod 777 {} \;
266 # Build one huge tarfile for the entire distribution.
267 build_tarfile gcc-${RELEASE} `basename ${SOURCE_DIRECTORY}`
269 # Now, build one for each of the languages.
270 build_tarfile gcc-ada-${RELEASE} ${ADA_DIRS}
271 build_tarfile gcc-chill-${RELEASE} ${CHILL_DIRS}
272 build_tarfile gcc-g++-${RELEASE} ${CPLUSPLUS_DIRS}
273 build_tarfile gcc-g77-${RELEASE} ${FORTRAN_DIRS}
274 build_tarfile gcc-java-${RELEASE} ${JAVA_DIRS}
275 build_tarfile gcc-objc-${RELEASE} ${OBJECTIVEC_DIRS}
276 build_tarfile gcc-testsuite-${RELEASE} ${TESTSUITE_DIRS}
278 # The core is everything else.
279 EXCLUDES=""
280 for x in ${ADA_DIRS} ${CHILL_DIRS} ${CPLUSPLUS_DIRS} ${FORTRAN_DIRS} \
281 ${JAVA_DIRS} ${OBJECTIVEC_DIRS} ${TESTSUITE_DIRS}; do
282 EXCLUDES="${EXCLUDES} --exclude $x"
283 done
284 build_tarfile gcc-core-${RELEASE} ${EXCLUDES} \
285 `basename ${SOURCE_DIRECTORY}`
287 # Build .bz2 files.
288 for f in ${FILE_LIST}; do
289 bzfile=${f%.gz}.bz2
290 (zcat $f | ${BZIP2} > ${bzfile}) || error "Could not create ${bzfile}"
291 FILE_LIST="${FILE_LIST} ${bzfile}"
292 done
295 # Build diffs against an old release.
296 build_diffs() {
297 old_dir=${1%/*}
298 old_file=${1##*/}
299 old_vers=${old_file%.tar.gz}
300 old_vers=${old_vers#gcc-}
301 inform "Building diffs against version $old_vers"
302 for f in gcc gcc-g++ gcc-g77 gcc-java gcc-objc gcc-testsuite gcc-core; do
303 old_tar=${old_dir}/${f}-${old_vers}.tar.gz
304 new_tar=${WORKING_DIRECTORY}/${f}-${RELEASE}.tar.gz
305 if [ -e $old_tar ] && [ -e $new_tar ]; then
306 build_diff $old_tar gcc-${old_vers} $new_tar gcc-${RELEASE} \
307 ${f}-${old_vers}-${RELEASE}.diff.gz
309 done
312 # Build an individual diff.
313 build_diff() {
314 changedir "${WORKING_DIRECTORY}"
315 tmpdir=gccdiff.$$
316 mkdir $tmpdir || error "Could not create directory $tmpdir"
317 changedir $tmpdir
318 tar xfz $1 || error "Could not unpack $1 for diffs"
319 tar xfz $3 || error "Could not unpack $3 for diffs"
320 ${DIFF} $2 $4 > ../${5%.gz}
321 if [ $? -eq 2 ]; then
322 error "Trouble making diffs from $1 to $3"
324 ${GZIP} ../${5%.gz} || error "Could not gzip ../${5%.gz}"
325 changedir ..
326 rm -rf $tmpdir
327 FILE_LIST="${FILE_LIST} $5"
330 # Upload the files to the FTP server.
332 upload_files() {
333 inform "Uploading files"
335 changedir "${WORKING_DIRECTORY}"
337 # Make sure the directory exists on the server.
338 if [ $LOCAL -eq 0 ]; then
339 ${SSH} -l ${GCC_USERNAME} ${GCC_HOSTNAME} mkdir ${FTP_PATH}
340 else
341 mkdir -p "${FTP_PATH}" \
342 || error "Could not create \`${FTP_PATH}'"
345 for x in gcc*.gz gcc*.bz2; do
346 if [ -e ${x} ]; then
347 # Make sure the file will be readable on the server.
348 chmod a+r ${x}
349 # Copy it.
350 ${SCP} ${x} ${FTP_PATH} || \
351 error "Could not upload ${x}"
353 done
356 ########################################################################
357 # Initialization
358 ########################################################################
360 # Today's date.
361 DATE=`date "+%Y%m%d"`
362 LONG_DATE=`date "+%Y-%m-%d"`
364 # The CVS server containing the GCC repository.
365 CVS_SERVER="gcc.gnu.org"
366 # The path to the repository on that server.
367 CVS_REPOSITORY="/cvs/gcc"
368 # The CVS protocol to use.
369 CVS_PROTOCOL="ext"
370 # The username to use when connecting to the server.
371 CVS_USERNAME="${USER}"
373 # The machine to which files will be uploaded.
374 GCC_HOSTNAME="gcc.gnu.org"
375 # The name of the account on the machine to which files are uploaded.
376 GCC_USERNAME="gccadmin"
377 # The directory in which the files will be placed.
378 FTP_PATH="~ftp/pub/gcc"
380 # The major number for the release. For release `3.0.2' this would be
381 # `3'
382 RELEASE_MAJOR=""
383 # The minor number for the release. For release `3.0.2' this would be
384 # `0'.
385 RELEASE_MINOR=""
386 # The revision number for the release. For release `3.0.2' this would
387 # be `2'.
388 RELEASE_REVISION=""
389 # The complete name of the release.
390 RELEASE=""
392 # The name of the branch from which the release should be made.
393 BRANCH=""
395 # The tag to apply to the sources used for the release.
396 TAG=""
398 # The old tarballs from which to generate diffs.
399 OLD_TARS=""
401 # The directory that will be used to construct the release. The
402 # release itself will be placed in a subdirectory of this diretory.
403 DESTINATION=${HOME}
404 # The subdirectory.
405 WORKING_DIRECTORY=""
406 # The directory that will contain the GCC sources.
407 SOURCE_DIRECTORY=""
409 # The directories that should be part of the various language-specific
410 # tar files. These are all relative to the top of the source tree.
411 ADA_DIRS="gcc/ada"
412 CHILL_DIRS="gcc/ch libchill"
413 CPLUSPLUS_DIRS="gcc/cp libstdc++-v3"
414 FORTRAN_DIRS="gcc/f libf2c"
415 JAVA_DIRS="gcc/java libjava libffi fastjar zlib boehm-gc"
416 OBJECTIVEC_DIRS="gcc/objc libobjc"
417 TESTSUITE_DIRS="gcc/testsuite"
419 # Non-zero if this is the final release, rather than a prerelease.
420 FINAL=0
422 # Non-zero if we are building a snapshot, and don't build gcc or
423 # include generated files.
424 SNAPSHOT=0
426 # Non-zero if we are running locally on gcc.gnu.org, and use local CVS
427 # and copy directly to the FTP directory.
428 LOCAL=0
430 # Major operation modes.
431 MODE_DIFFS=0
432 MODE_SOURCES=0
433 MODE_TARFILES=0
434 MODE_UPLOAD=0
436 # Files generated to upload.
437 FILE_LIST=""
439 # Programs we use.
441 BZIP2="${BZIP2:-bzip2}"
442 CVS="${CVS:-cvs -f -Q -z9}"
443 DIFF="${DIFF:-diff -Nrc3pad}"
444 ENV="${ENV:-env}"
445 GZIP="${GZIP:-gzip --best}"
446 SCP="${SCP:-scp -p}"
447 SSH="${SSH:-ssh}"
448 TAR="${TAR:-tar}"
450 ########################################################################
451 # Command Line Processing
452 ########################################################################
454 # Parse the options.
455 while getopts "d:fr:u:t:p:sl" ARG; do
456 case $ARG in
457 d) DESTINATION="${OPTARG}";;
458 r) RELEASE="${OPTARG}";;
459 t) TAG="${OPTARG}";;
460 u) CVS_USERNAME="${OPTARG}";;
461 f) FINAL=1;;
462 s) SNAPSHOT=1;;
463 l) LOCAL=1
464 SCP=cp
465 FTP_PATH=~ftp/pub/gcc
466 PATH=~:/usr/local/bin:$PATH;;
467 p) OLD_TARS="${OLD_TARS} ${OPTARG}"
468 if [ -d ${OPTARG} ]; then
469 error "-p argument must name a tarball"
470 fi;;
471 \?) usage;;
472 esac
473 done
474 shift `expr ${OPTIND} - 1`
476 # Perform consistency checking.
477 if [ ${LOCAL} -eq 0 ] && [ -z ${CVS_USERNAME} ]; then
478 error "No username specified"
481 if [ ! -d ${DESTINATION} ]; then
482 error "\`${DESTINATION}' is not a directory"
485 if [ $SNAPSHOT -eq 0 ]; then
486 if [ -z ${RELEASE} ]; then
487 error "No release number specified"
490 # Compute the major and minor release numbers.
491 RELEASE_MAJOR=`echo $RELEASE | awk --assign FS=. '{ print $1; }'`
492 RELEASE_MINOR=`echo $RELEASE | awk --assign FS=. '{ print $2; }'`
493 RELEASE_REVISION=`echo $RELEASE | awk --assign FS=. '{ print $3; }'`
495 if [ -z "${RELEASE_MAJOR}" ] || [ -z "${RELEASE_MINOR}" ]; then
496 error "Release number \`${RELEASE}' is invalid"
499 # Compute the full name of the release.
500 if [ -z "${RELEASE_REVISION}" ]; then
501 RELEASE="${RELEASE_MAJOR}.${RELEASE_MINOR}"
502 else
503 RELEASE="${RELEASE_MAJOR}.${RELEASE_MINOR}.${RELEASE_REVISION}"
506 # Compute the name of the branch, which is based solely on the major
507 # and minor release numbers.
508 BRANCH="gcc-${RELEASE_MAJOR}_${RELEASE_MINOR}-branch"
510 # If this is not a final release, set various parameters acordingly.
511 if [ ${FINAL} -ne 1 ]; then
512 RELEASE="${RELEASE}-${DATE}"
513 FTP_PATH="${FTP_PATH}/snapshots/"
514 else
515 FTP_PATH="${FTP_PATH}/releases/gcc-${RELEASE}/"
517 else
518 RELEASE=$DATE
519 # For now snapshots come from the 3.1 branch.
520 BRANCH=gcc-3_1-branch
521 FTP_PATH="${FTP_PATH}/snapshots/${LONG_DATE}"
522 TAG=gcc_ss_${DATE}
524 # Building locally on gcc.gnu.org, we know what the last snapshot date
525 # was.
526 if [ $LOCAL -ne 0 ]; then
527 LAST_DATE=`cat ~/.snapshot_date`
528 LAST_LONG_DATE=`date --date=$LAST_DATE +%Y-%m-%d`
529 LAST_DIR=~ftp/pub/gcc/snapshots/${LAST_LONG_DATE}
530 OLD_TARS=${LAST_DIR}/gcc-${LAST_DATE}.tar.gz
534 # Compute the name of the WORKING_DIRECTORY and the SOURCE_DIRECTORY.
535 WORKING_DIRECTORY="${DESTINATION}/gcc-${RELEASE}"
536 SOURCE_DIRECTORY="${WORKING_DIRECTORY}/gcc-${RELEASE}"
538 # Recompute the names of all the language-specific directories,
539 # relative to the WORKING_DIRECTORY.
540 ADA_DIRS=`adjust_dirs ${ADA_DIRS}`
541 CHILL_DIRS=`adjust_dirs ${CHILL_DIRS}`
542 CPLUSPLUS_DIRS=`adjust_dirs ${CPLUSPLUS_DIRS}`
543 FORTRAN_DIRS=`adjust_dirs ${FORTRAN_DIRS}`
544 JAVA_DIRS=`adjust_dirs ${JAVA_DIRS}`
545 OBJECTIVEC_DIRS=`adjust_dirs ${OBJECTIVEC_DIRS}`
546 TESTSUITE_DIRS=`adjust_dirs ${TESTSUITE_DIRS}`
548 # Set up CVSROOT.
549 if [ $LOCAL -eq 0 ]; then
550 CVSROOT=":${CVS_PROTOCOL}:${CVS_USERNAME}@"
551 CVSROOT="${CVSROOT}${CVS_SERVER}:${CVS_REPOSITORY}"
552 else
553 CVSROOT="${CVS_REPOSITORY}"
555 export CVSROOT
557 ########################################################################
558 # Main Program
559 ########################################################################
561 # Handle the major modes.
562 while [ $# -ne 0 ]; do
563 case $1 in
564 diffs) MODE_DIFFS=1;;
565 sources) MODE_SOURCES=1;;
566 tarfiles) MODE_TARFILES=1;;
567 upload) MODE_UPLOAD=1;;
568 all) MODE_SOURCES=1; MODE_TARFILES=1; MODE_DIFFS=1; MODE_UPLOAD=1;;
569 *) error "Unknown mode $1";;
570 esac
571 shift
572 done
574 # Build the source directory.
576 if [ $MODE_SOURCES -ne 0 ]; then
577 build_sources
580 # Build the tar files.
582 if [ $MODE_TARFILES -ne 0 ]; then
583 build_tarfiles
586 # Build diffs
588 if [ $MODE_DIFFS -ne 0 ]; then
589 # Possibly build diffs.
590 if [ -n "$OLD_TARS" ]; then
591 for old_tar in $OLD_TARS; do
592 build_diffs $old_tar
593 done
597 # Upload them to the FTP server.
599 if [ $MODE_UPLOAD -ne 0 ]; then
600 upload_files
602 # For snapshots, make some further updates.
603 if [ $SNAPSHOT -ne 0 ] && [ $LOCAL -ne 0 ]; then
604 # Update links on the FTP server.
605 TEXT_DATE=`date --date=$DATE +%B\ %d,\ %Y`
606 cd ~ftp/pub/gcc/snapshots
607 sed -e "s%@DATE@%$DATE%g" -e "s%@LAST_DATE@%$LAST_DATE%g" \
608 -e "s%@LONG_DATE@%$LONG_DATE%g" \
609 -e "s%@TEXT_DATE@%$TEXT_DATE%g" < ~/scripts/snapshot-README > $$
610 mv $$ README
611 sed -e "s%@DATE@%$DATE%g" -e "s%@LAST_DATE@%$LAST_DATE%g" \
612 -e "s%@LONG_DATE@%$LONG_DATE%g" \
613 -e "s%@TEXT_DATE@%$TEXT_DATE%g" < ~/scripts/snapshot-index.html > $$
614 mv $$ index.html
616 touch LATEST-IS-$LONG_DATE
617 rm -f LATEST-IS-$LAST_LONG_DATE
619 # Update snapshot date file.
620 changedir ~
621 echo $DATE >.snapshot_date
623 # Update gcc_latest_snapshot tag.
624 ${CVS} rtag -d gcc_latest_snapshot gcc
625 ${CVS} rtag -rgcc_ss_${DATE} gcc_latest_snapshot gcc
627 # Announce the snapshot.
628 export QMAILHOST=gcc.gnu.org
629 mail -s "gcc-ss-$DATE is now available" gcc@gcc.gnu.org < ~ftp/pub/gcc/snapshots/README
631 # Remove working directory
632 rm -rf ${WORKING_DIRECTORY}